Subject: Re: PROBLEM: IProute hangs after running traffic shaping scripts

From: Patrick McHardy <[email-masked]>
Date: Mon, 08 Nov 2004 17:12:00 +0100

Thomas Graf wrote:

>>+	/* unlink inner qdiscs from dev->qdisc_list immediately */
>>+	if (qdisc->ops->cl_ops != NULL)
>>+		list_add(&qdisc->list, &cql);
>>    
>>
>
>I think you should extend the above to:
>
>if (qdisc->ops->cl_ops != NULL && !list_empty(&qdisc->list))
>
>Otherwise you might unlink entries just added before the
>rcu callback and it prevents an unneeded attempt to delete
>qdiscs for inner classful qdiscs
>  
>
There is some optimization possible, I will do this for the final
patch. But I don't understand the problem you refer to, can you
please explain ?

Regards
Patrick